<img src="https://github.com/lincc-frameworks/tape/blob/main/docs/DARK_Combo_sm.png?raw=true" width="300" height="100">

# HiPSCat

[![Template](https://img.shields.io/badge/Template-LINCC%20Frameworks%20Python%20Project%20Template-brightgreen)](https://lincc-ppt.readthedocs.io/en/stable/)

[![PyPI](https://img.shields.io/pypi/v/hipscat?color=blue&logo=pypi&logoColor=white)](https://pypi.org/project/hipscat/)
[![Conda](https://img.shields.io/conda/vn/conda-forge/hipscat.svg?color=blue&logo=condaforge&logoColor=white)](https://anaconda.org/conda-forge/hipscat)

[![GitHub Workflow Status](https://img.shields.io/github/actions/workflow/status/astronomy-commons/hipscat/smoke-test.yml)](https://github.com/astronomy-commons/hipscat/actions/workflows/smoke-test.yml)
[![codecov](https://codecov.io/gh/astronomy-commons/hipscat/branch/main/graph/badge.svg)](https://codecov.io/gh/astronomy-commons/hipscat)
[![Read the Docs](https://img.shields.io/readthedocs/hipscat)](https://hipscat.readthedocs.io/)
[![benchmarks](https://img.shields.io/github/actions/workflow/status/astronomy-commons/hipscat/asv-main.yml?label=benchmarks)](https://astronomy-commons.github.io/hipscat/)

## Hierarchical Progressive Survey Catalog

A HiPSCat catalog is a partitioning of objects on a sphere. Its purpose is for 
storing data from large astronomy surveys, but could probably be used for other 
use cases where you have large data with some spherical properties.

Check out our [ReadTheDocs site](https://hipscat.readthedocs.io/en/stable/)
for more information on partitioning, installation, and contributing.

See related projects:

* HiPSCat Import ([on GitHub](https://github.com/astronomy-commons/hipscat-import))
  ([on ReadTheDocs](https://hipscat-import.readthedocs.io/en/stable/))
* LSDB ([on GitHub](https://github.com/astronomy-commons/lsdb)) 
  ([on ReadTheDocs](https://lsdb.readthedocs.io/en/stable/))

## Contributing

[![GitHub issue custom search in repo](https://img.shields.io/github/issues-search/astronomy-commons/hipscat?color=purple&label=Good%20first%20issues&query=is%3Aopen%20label%3A%22good%20first%20issue%22)](https://github.com/astronomy-commons/hipscat/issues?q=is%3Aissue+is%3Aopen+label%3A%22good+first+issue%22)

See the [contribution guide](https://hipscat.readthedocs.io/en/stable/guide/contributing.html)
for completed installation instructions and contribution best practices.

## Acknowledgements

This project is supported by Schmidt Sciences.

This project is based upon work supported by the National Science Foundation under Grant No. AST-2003196.

This project acknowledges support from the DIRAC Institute in the Department of Astronomy at the University of Washington. The DIRAC Institute is supported through generous gifts from the Charles and Lisa Simonyi Fund for Arts and Sciences, and the Washington Research Foundation.